from typing import Any, List

from agno.tools import Toolkit
from nostr_sdk import NostrClient  # type: ignore

from agentstr.models import AgentProfile, MerchantProduct, MerchantStall

class MerchantTools(Toolkit):
    _nostr_client: NostrClient
    _profile: AgentProfile
    _stalls: List[MerchantStall]
    _products: List[MerchantProduct]

    def __init__(
        self,
        merchant_profile: AgentProfile,
        relay: str,
        stalls: List[MerchantStall],
        products: List[MerchantProduct],
    ) -> None: ...
    def get_nostr_client(self) -> NostrClient: ...
    def get_profile(self) -> str: ...
    def get_relay(self) -> str: ...
    def get_products(self) -> str: ...
    def get_stalls(self) -> str: ...
    def publish_all_products(self) -> str: ...
    def publish_all_stalls(self) -> str: ...
    def publish_new_product(self, product: MerchantProduct) -> str: ...
    def publish_product_by_name(self, product_name: str) -> str: ...
    def publish_products_by_stall_name(self, stall_name: str) -> str: ...
    def publish_profile(self) -> str: ...
    def publish_new_stall(self, stall: MerchantStall) -> str: ...
    def publish_stall_by_name(self, stall_name: str) -> str: ...
    def remove_all_products(self) -> str: ...
    def remove_all_stalls(self) -> str: ...
    def remove_product_by_name(self, product_name: str) -> str: ...
    def remove_stall_by_name(self, stall_name: str) -> str: ...
